
#include <sys/osinfo.h>
#include <i86.h>
#include <time.h>
#include <fish_time.h>
#include <sys/proc_msg.h>
#include <i86.h>
#include <malloc.h>

struct _timesel __far *fish_qnx_time(void)
{
	static struct _timesel __far *tptr = NULL;

	if (tptr == 0L) {
		struct _osinfo *osdata;

		osdata = alloca(sizeof(struct _osinfo));	/* on stack! */
		if (qnx_osinfo(0,osdata)==-1) return(NULL);
		tptr = MK_FP(osdata->timesel,0);
	}

	return(tptr);
}

time_t fish_time ( time_t *time )
{
	struct _timesel __far *ptr;
	time_t result;

	if ((ptr=fish_qnx_time())==NULL) result = 0;
	else {
		do {
			result = ptr->seconds;
		} while (result != ptr->seconds);
	}

	if (time!=NULL) *time = result;
	return(result);
}

